<?php
/**
  * Enviar correo de encuesta despues de un pedido
  * Version 1.0
  * Author Juan Castells
  * copyright 2013 www.juancastells.com
  *
  */


include(dirname(__FILE__).'/../../config/config.inc.php');

require_once('encuesta.php');



$module = new Encuesta();



if (!Module::isInstalled($module->name))

	exit;

else

{

	if (isset($_GET['secure_key']))

	{

		$secureKey = md5(_COOKIE_KEY_.Configuration::get('PS_SHOP_NAME'));

		if (!empty($secureKey) AND $secureKey === $_GET['secure_key'])

		{
		$contenido_mail_cab="Envio de emails de encuesta a clientes cuyos pedidos se han entregado en un plazo dado";
		$contenido_mail="";
		
		//Consulta de orders con status 5 (Entregado) y sin check de encuesta.
		if ($orders = Order::getOrderIdsByStatus(5)){
			$cont=0;
			foreach ($orders AS &$order_id)
			{
				$encuesta = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
				SELECT encuesta, oh.date_add AS fecha
				FROM '._DB_PREFIX_.'orders o, '._DB_PREFIX_.'order_history oh
				WHERE o.id_order='.(int)($order_id).' AND o.id_order=oh.id_order AND id_order_state=5');
				if($encuesta[0]['encuesta']==0){
					
					$myOrder = new Order((int)($order_id));
					$customer = new Customer ((int)($myOrder->id_customer));
					//calculamos tiempo 
					$fecha1=substr($encuesta[0]['fecha'],0,10);
					$fecha2=date("Y-m-d");
					$hora1 = substr($encuesta[0]['fecha'],11,10);
					$hora2 = date("H:i:s");
					$tiempopasado= (int)($module->diff_sinp($fecha1,$fecha2,$hora1,$hora2,"d"));//Para pruebas se puede poner "h" para que lo haga por horas
					$tiempoenvio = (int)Configuration::get('ENCUESTA_DIAS');
					
					if($tiempopasado>=$tiempoenvio){
						//enviamos email
						$data = array('{email}' => $customer->email, '{firstname}' =>  stripslashes($customer->firstname), '{lastname}' => stripslashes($customer->lastname), '{encuesta_link}' => stripslashes(Configuration::get('ENCUESTA_ENLACE')), '{order_name}' => sprintf("#%06d", (int)((int)($order_id))));
						if (Validate::isEmail($customer->email)){
							if (Mail::Send((int)$myOrder->id_lang, 'encuesta', Mail::l('Encuesta de satisfaccion', (int)$myOrder->id_lang), $data, $customer->email, $customer->firstname." ".$customer->lastname, $configuration['PS_SHOP_EMAIL'], $configuration['PS_SHOP_NAME'], NULL, NULL, dirname(__FILE__).'/mails/')){
								//Si todo ha ido bien modificamos estado encuesta en tabla.
								$actualizar = Db::getInstance()->ExecuteS('
								UPDATE '._DB_PREFIX_.'orders set encuesta=1 
								WHERE id_order='.(int)($order_id));
								$cont++;
								$contenido_mail.="\n\rEnviar encuesta a pedido ".(int)($order_id);
							}else{
								$contenido_mail.="\n\rError al enviar encuesta a pedido ".(int)($order_id);
							}
						}
					}
				}
				
			}
			if($cont==0)
				$contenido_mail.="\n\rNo hay pedidos pendientes de envio de encuesta";
		}else{
			$contenido_mail.="\n\rNo hay pedidos en estado entregado";
		}
		if ($contenido_mail!=""){}
			$contenido_mail=$contenido_mail_cab.$contenido_mail;
			//recuperamos valores de contacto principal de la tienda en espaol
			$contact = new Contact(1, 3);
			
			$cabeceras = 'From: '.$contact->email;
			mail($contact->email, 'Envio encuestas', $contenido_mail,$cabeceras);  
			//echo $contenido_mail;
		}

	}
	
}